<?php
// ----------------------------------------------------------------------
// Fast Click SQL - Advanced Clicks Counter System
// Copyright (c) 2003-2006 by Dmitry Ignatyev (ftrainsoft@mail.ru)
// http://www.FTRSoft.com/
// ----------------------------------------------------------------------
// Original Author of file: Dmitry Ignatyev
// ----------------------------------------------------------------------

chdir('..');

$CFG['CDIR'] = "./common";
require($CFG['CDIR']."/error.php");
require($CFG['CDIR']."/init.php");

header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

// Initialization
InitVars(1);
if($ERR['flag']) {
  err('upgrade.php||initialization was failed');
  log_out();
  err_scr_out();
  exit;
 }

// Upgrade from 1.1.*:
$vr = 1;
$sth = $DB->query("SELECT l_referrer FROM ".$PREFIX."stats WHERE 1=0");
if(!$sth) {
  err('upgrade.php||needed upgrading from 1.1.* -- '.$DB->error());

  $sth = $DB->query("ALTER TABLE ".$PREFIX."stats ADD `l_referrer` VARCHAR( 250 )");
  if(!$sth) {
    err('upgrade.php||upgrade 1 was failed -- '.$DB->error());
    log_out();
    err_scr_out();
    exit;
   }
  $sth = $DB->query("ALTER TABLE ".$PREFIX."links CHANGE `URL` `URL` VARCHAR( 250 ) DEFAULT 'http://'");
  if(!$sth) {
    err('upgrade.php||upgrade 2 was failed -- '.$DB->error());
    log_out();
    err_scr_out();
    exit;
   }
  $vr += 1;
 }

// Upgrade from v1.1.3
$sth = $DB->query("DESCRIBE ".$PREFIX."visitors VID");
$row = $sth->fetchrow_array();
if(strrpos($row[1], '5')) {
  err('upgrade.php||needed upgrading from 1.1.3 -- '.$DB->error());

  $sth = $DB->query("ALTER TABLE ".$PREFIX."category CHANGE `CID` `CID` MEDIUMINT( 9 ) UNSIGNED NOT NULL AUTO_INCREMENT ");
  if(!$sth) {
    err('upgrade.php||upgrade 1 was failed -- '.$DB->error());
    log_out();
    err_scr_out();
    exit;
   }
  $sth = $DB->query("ALTER TABLE ".$PREFIX."links CHANGE `LID` `LID` MEDIUMINT( 9 ) UNSIGNED NOT NULL AUTO_INCREMENT, ".
                    "CHANGE `CID` `CID` MEDIUMINT( 9 ) UNSIGNED DEFAULT '1' NOT NULL");
  if(!$sth) {
    err('upgrade.php||upgrade 2 was failed -- '.$DB->error());
    log_out();
    err_scr_out();
    exit;
   }
  $sth = $DB->query("ALTER TABLE ".$PREFIX."stats CHANGE `LID` `LID` MEDIUMINT( 9 ) DEFAULT '0' NOT NULL, ".
                    "CHANGE `CID` `CID` MEDIUMINT( 9 ) DEFAULT NULL, ".
                    "CHANGE `VID` `VID` MEDIUMINT( 9 ) DEFAULT NULL");
  if(!$sth) {
    err('upgrade.php||upgrade 3 was failed -- '.$DB->error());
    log_out();
    err_scr_out();
    exit;
   }
  $sth = $DB->query("ALTER TABLE ".$PREFIX."visitors CHANGE `VID` `VID` MEDIUMINT( 9 ) UNSIGNED NOT NULL AUTO_INCREMENT");
  if(!$sth) {
    err('upgrade.php||upgrade 4 was failed -- '.$DB->error());
    log_out();
    err_scr_out();
    exit;
   }

  $vr += 1;
 } 

// Upgrade from v1.1.5
$sth = $DB->query("DESCRIBE ".$PREFIX."visitors IP");
$row = $sth->fetchrow_array();
if(strrpos($row[1], '10') > 1) {
  err('upgrade.php||needed upgrading from 1.1.5 -- '.$DB->error());

  $sth = $DB->query("ALTER TABLE ".$PREFIX."visitors CHANGE `IP` `IP` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
                     CHANGE `Proxy` `Proxy` INT( 11 ) UNSIGNED NULL DEFAULT NULL");
  if(!$sth) {
    err('upgrade.php||upgrade 1 was failed -- '.$DB->error());
    log_out();
    err_scr_out();
    exit;
   }

  $sth = $DB->query("ALTER TABLE ".$PREFIX."visitors CHANGE `IsBot` `IsBot` ENUM( 'n', 'y', 'o' ) DEFAULT 'n',
                     ADD `Browser_ver` VARCHAR( 10 ) NULL AFTER `Browser`,
                     ADD `OS_ver` VARCHAR( 20 ) NULL AFTER `OS`");
  if(!$sth) {
    err('upgrade.php||upgrade 2 was failed -- '.$DB->error());
    log_out();
    err_scr_out();
    exit;
   }

  $vr += 1;
 } 


if($vr == 4)
  echo "<b>Upgrade from v1.1.* has passed successfully.</b>";
else if($vr == 3)
  echo "<b>Upgrade from v1.1.3 has passed successfully.</b>";
else if($vr == 2)
  echo "<b>Upgrade from v1.1.5 has passed successfully.</b>";
else
  echo "<b>Upgrade has passed successfully. Database change is not required.</b>";

echo "<b><font color=\"red\"> Please, delete upgrade.php file.</font></b>";
exit;
//unlink("admin/upgrade.php");
